//// Ejercicio 6-2 ////
////---------------////
clear;
clc;
// ----- Parametros de la planta - Laminadora --------------//
La=0;          // Inductancia de armadura del motor DC [H]
Ra=5;          // Resistencia de armadura del motor DC [Ohms]
Kt=0.721;      // Constante de Torque del motor DC [Nm/A]
Kw=0.721;      // Constante de Generación del motor DC [Vs/rad]
J=0.001;       // Momento de incercia sobre el eje del motor [Kgm2]
B=0.01;        // Rozamiento sobre el eje del motor [Nms/rad]
//Kl=0.01;       // Relación de transforfación engranaje-cremallera [m/rev]
Kl=0.001591;   // Relación de transforfación engranaje-cremallera [m/rad]
Td=0.01;       // Retardo de transporte [s]
Ks=100;        // Ganancia sensor de espesor [V/m]
K=1;           // Ganancia amplificador de potencia [adimensional]

// Función de transferencia continua//

s=%s;
numGP=K*Kl*Ks*Kt;
denGP=(s)*(s*J*Ra+B*Ra+Kt*Kw);
GP=syslin('c',numGP/denGP);
zpk(GP)

// Función de transferencia discreta//
Ts=0.01;                      // Periodo de muestreo
[Ds,numGPD,denGPD]=ss2tf(dscr(GP,Ts));
z=%z;
denGPD=z*denGPD;    // Se incorpora retardo de una muestra
GPD=syslin('d',numGPD/denGPD+Ds);
zpk(GPD)

// Transferencia a lazo cerrado discreta
H=1;    // Ganancia de realimentacion
TLC=GPD/(1+GPD*H);
zpk(TLC)

NUMTLC=coeff(TLC.num);
DENTLC=coeff(TLC.den);

// ---------------------------------------------------------------------
// Completo con ceros los coeficientes hasta llegar al orden del sistema

if length(NUMTLC)==3 then
    NUMTLC=NUMTLC;
else
    for i=length(NUMTLC)+1:3
        NUMTLC(i)=0;
    end
end
// ---------------------------------------------------------------------

// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ---------------------- Modelo MCC ----------------------------------
// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

Acc=[0 1 0; 0 0 1; -DENTLC(1) -DENTLC(2) -DENTLC(3)]
Bcc=[0;0;1]
Ccc=[NUMTLC(1) NUMTLC(2) NUMTLC(3)]

// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ---------------------- Modelo MCO ----------------------------------
// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

Aco=[0 0 -DENTLC(1); 1 0 -DENTLC(2); 0 1 -DENTLC(3)]
Bco=[NUMTLC(1); NUMTLC(2); NUMTLC(3)]
Cco=[0 0 1]

//---------------------------------------------------------------------
